/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.PendidikanDto;
import com.portofolio.service.PendidikanService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/pendidikan")
public class PendidikanController extends LocaleController {
    @Lazy
	@Autowired
    private PendidikanService pendidikanService;
    
    
    @ApiOperation("Api Untuk Menyimpan Pendidikan")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PendidikanDto entity,HttpServletRequest request) {
        Map<String, Object> result = pendidikanService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Pendidikan")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdPendidikan", required = true) String kdPendidikan,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody PendidikanDto entity, HttpServletRequest request) {
        Map<String, Object> result = pendidikanService.update(entity,kdPendidikan,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Pendidikan Berdasarkan KdPendidikan")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdPendidikan", required = true) String kdPendidikan,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = pendidikanService.deleteById(kdPendidikan, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Pendidikan")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaPendidikan") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaPendidikan", required = false) String namaPendidikan,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = pendidikanService.grid(page, rows, sort, dir, namaPendidikan,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Pendidikan Berdasarkan kdPendidikan")
    @GetMapping("/findByKdPendidikan")
    public ResponseEntity<Map<String, Object>> findByKdPendidikan(
    		@RequestParam(value = "kdPendidikan", required = true) String kdPendidikan, 
    		HttpServletRequest request) {
        Map<String, Object> result = pendidikanService.findByKdPendidikan(kdPendidikan);
        return RestUtil.getJsonResponse(result);
    }


}
